"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var utils_2 = require("../utils/utils");
var en_1 = require("./en");
var ja_1 = require("./ja");
var langs = {
    ja: ja_1.ja,
    en: en_1.en,
};
var resource = utils_1.deepAssign({}, langs.en, langs.ja);
function setup(lang) {
    "use strict";
    if (lang === void 0) { lang = "ja"; }
    resource = utils_1.deepAssign({}, langs.en, langs.ja, langs[lang]);
}
exports.setup = setup;
var sprintf;
if (typeof window !== "undefined" && window.sprintf) {
    sprintf = window.sprintf;
}
else {
    sprintf = require("sprintf-js").sprintf;
}
utils_2.isNodeJS(); // TODO utilsをi18n.ts内で使わないと実行時エラーになる
function t(str) {
    "use strict";
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var parts = str.split(".");
    var base = resource;
    parts.forEach(function (part) {
        base = base[part];
    });
    if (typeof base !== "string") {
        throw new Error("unknown key: " + str);
    }
    return sprintf.apply(void 0, [base].concat(args));
}
exports.t = t;
setup();
//# sourceMappingURL=i18n.js.map