import { Book, ContentChunk } from "../model/compilerModel";
import { AcceptableSyntaxes } from "./analyzer";
import { Builder } from "../builder/builder";
/**
 * IAnalyzerで処理した後の構文木について構文上のエラーがないかチェックする。
 * また、Builderと対比させて、未実装の候補がないかをチェックする。
 */
export interface Validator {
    start(book: Book, acceptableSyntaxes: AcceptableSyntaxes, builders: Builder[]): void;
}
export declare class DefaultValidator implements Validator {
    acceptableSyntaxes: AcceptableSyntaxes;
    builders: Builder[];
    start(book: Book, acceptableSyntaxes: AcceptableSyntaxes, builders: Builder[]): void;
    checkBuilder(book: Book, acceptableSyntaxes: AcceptableSyntaxes, builders?: Builder[]): void;
    checkBook(book: Book): void;
    checkChunk(chunk: ContentChunk): void;
    chechBlockGraphTool(chunk: ContentChunk): void;
    resolveSymbolAndReference(book: Book): void;
}
